1 REM Demo for using the Model 20B with the Model 134
5 Q = 1: REM number of thermometers - 1
10 ADC = 600: CLS
20 G(0) = .8: G(1) = .8: K(0) = 11.4: K(1) = 11.4: REM put all G & K values here
30 OUT ADC, 0
40 FOR J = 0 TO Q
50 FOR N = 0 TO 7
60 GOSUB 200: V(N) = V
70 NEXT N
80 C = (V(3) - V(0)) / K(J) - 273
90 FOR N = 1 TO 7: IF N = 3 THEN 130
100 V = (V(N) - V(0)) * G(J)
110 GOSUB 300: REM Linearize
115 PRINT "Thermometer #"; J, "T.C. #"; N - INT(N / 3) + INT(N / 6),
120 PRINT USING "####.#"; T;
125 PRINT "   "
130 NEXT N
140 NEXT J
160 LOCATE 1, 1: GOTO 30
199 REM read volts
200 OUT ADC, J * 16 + N: REM select channel
210 FOR P = 1 TO 200: NEXT P: REM 1 milisecond delay for settling
215 X = INP(ADC + 2): REM start conversion
220 IF (INP(ADC) AND 2) = 0 THEN GOTO 220: REM check status bit
225 COUNT = 0: AVERAGE = 40: REM set average larger for smoother data
230 FOR X = 1 TO AVERAGE
235 LOW = INP(ADC + 1)
240 HIGH = (INP(ADC + 2) XOR 128): REM read the answer
245 COUNT = COUNT + LOW + HIGH * 256
250 NEXT X
255 COUNT = COUNT / AVERAGE
260 V = (COUNT - 32768!) * .152588: REM scale in MV
265 RETURN
300 REM linearize type k
310 V = V + C * 4.07
320 IF V < 326 THEN T = V / 4.07: RETURN
330 IF V < 654 THEN T = 80 + (V - 326) / 4.11: RETURN
340 IF V < 1137 THEN T = 160 + (V - 654) / 4.02: RETURN
350 IF V < 1935 THEN T = 280 + (V - 1137) / 4.2: RETURN
360 IF V < 2932 THEN T = 470 + (V - 1935) / 4.26: RETURN
370 IF V < 3614 THEN T = 704 + (V - 2932) / 4.11: RETURN
380 IF V < 4276 THEN T = 870 + (V - 3614) / 3.94: RETURN
390 IF V < 4811 THEN T = 1038 + (V - 4276) / 3.77: RETURN
400 IF V < 5241 THEN T = 1180 + (V - 4811) / 3.58: RETURN
410 T = 1300 + (V - 5241) / 3.43: RETURN
500 REM linearize type t to -50 deg C
505 V = V + C * 4.04
510 IF V < -112 THEN T = -30 + (V + 112) / 3.53: RETURN
520 IF V < 0 THEN T = V / 3.74: RETURN
530 IF V < 202 THEN T = V / 4.04: RETURN
540 IF V < 474 THEN T = 50 + (V - 202) / 4.53: RETURN
550 IF V < 822 THEN T = 110 + (V - 474) / 4.968: RETURN
560 IF V < 1256 THEN T = 180 + (V - 822) / 5.425: RETURN
570 IF V < 1780 THEN T = 260 + (V - 1256) / 5.825: RETURN
580 T = 350 + (V - 1780) / 6.15: RETURN
600 REM linearize type e
620 V = V + C * 6.1
630 IF V < 366 THEN T = V / 6.1: RETURN
640 IF V < 836 THEN T = 60 + (V - 366) / 6.72: RETURN
650 IF V < 1487 THEN T = 130 + (V - 836) / 7.223: RETURN
660 IF V < 2494 THEN T = 220 + (V - 1487) / 7.74: RETURN
670 IF V < 5633 THEN T = 350 + (V - 2494) / 8.049: RETURN
680 IF V < 6878 THEN T = 740 + (V - 5633) / 7.785: RETURN
690 T = 900 + (V - 6878) / 7.6: RETURN
700 REM linearize type j
710 V = V + C * 5.2
730 IF V < 411 THEN T = V / 5.2: RETURN
740 IF V < 2738 THEN T = 79 + (V - 411) / 5.527: RETURN
750 IF V < 3367 THEN T = 500 + (V - 2738) / 5.72: RETURN
760 IF V < 3911 THEN T = 610 + (V - 3367) / 6.05: RETURN
770 T = 700 + (V - 3911) / 6.33: RETURN

